diff -rupN newpd/pd-0.45-0/tcl/dialog_prefs.tcl pd-0.45-0/tcl/dialog_prefs.tcl
--- newpd/pd-0.45-0/tcl/dialog_prefs.tcl	1969-12-31 19:00:00.000000000 -0500
+++ pd-0.45-0/tcl/dialog_prefs.tcl	2013-08-27 12:37:35.806358982 -0400
@@ -0,0 +1,372 @@
+# the find dialog panel is a bit unusual in that it is created directly by the
+# Tcl 'pd-gui'. Most dialog panels are created by sending a message to 'pd',
+# which then sends a message to 'pd-gui' to create the panel.
+
+package provide dialog_prefs 0.1
+
+package require pd_bindings
+package require dialog_gui
+
+namespace eval ::dialog_prefs:: {
+#    namespace export pdtk_
+}
+
+# mytoplevel isn't used here, but is kept for compatibility with other dialog ok procs
+proc ::dialog_prefs::ok {mytoplevel} {
+    return # hash this out later
+    variable find_history
+
+    if {$findstring eq ""} {
+        if {$::windowingsystem eq "aqua"} {bell}
+        return
+    }
+    if {$find_in_window eq ".pdwindow"} {
+        if {$::tcl_version < 8.5} {
+            # TODO implement in 8.4 style, without -all
+            set matches [.pdwindow.text search -nocase -- $findstring 0.0]
+        } else {
+            set matches [.pdwindow.text search -all -nocase -- $findstring 0.0]
+        }
+        .pdwindow.text tag delete sel
+        if {[llength $matches] > 0} {
+            foreach match $matches {
+                .pdwindow.text tag add sel $match "$match wordend"
+            }
+            .pdwindow.text see [lindex $matches 0]
+            lappend find_history $findstring
+        }
+    } else {
+        if {$findstring eq $previous_findstring \
+                && $wholeword_button == $previous_wholeword_button} {
+            pdsend "$find_in_window findagain"
+        } else {
+            pdsend [concat $find_in_window find [pdtk_encodedialog $findstring] \
+                        $wholeword_button]
+            set previous_findstring $findstring
+            set previous_wholeword_button $wholeword_button
+            lappend find_history $findstring
+        }
+    }
+    if {$::windowingsystem eq "aqua"} {
+        # (Mac OS X) hide panel after success, but keep it if unsuccessful by
+        # having the couldnotfind proc reopen it
+        cancel $mytoplevel
+    } else {
+        # (GNOME/Windows) find panel should retain focus after a find
+        # (yes, a bit of a kludge)
+        after 100 "raise .find; focus .find.entry"
+    }
+}
+
+# mytoplevel isn't used here, but is kept for compatibility with other dialog cancel procs
+proc ::dialog_prefs::cancel {mytoplevel} {
+    wm withdraw .prefs
+}
+
+# the find panel is opened from the menu and key bindings
+proc ::dialog_prefs::open_prefs_dialog {mytoplevel} {
+    if {[winfo exists .prefs]} {
+        wm deiconify .prefs
+        raise .prefs
+    } else {
+        create_dialog $mytoplevel
+    }
+    pdsend "pd audio-properties"
+    pdsend "pd midi-properties"
+    ::dialog_gui::create_gui_dialog .prefs.nb.gui
+#    need to think about what should get focus with ttk::notebook
+#    .prefs.entry selection range 0 end
+}
+
+proc ::dialog_prefs::dropdown_set {name value} {
+    if {$::windowingsystem eq "aqua"} {
+        set my_var [$name cget -textvariable]
+        set $my_var $value
+    } else {
+        $name set "$value"
+    }
+}
+
+proc ::dialog_prefs::dropdown_by_index {name variable values textvar} {
+    ::dialog_prefs::dropdown $name $variable $values $textvar
+}
+
+proc ::dialog_prefs::dropdown {name variable values args} {
+    set textvar $variable
+    if {$args ne ""} {set textvar $args}
+    if {$::windowingsystem eq "aqua"} {
+        ttk::menubutton $name -menu $name.menu -direction flush \
+            -textvariable $textvar -cursor boat
+        menu $name.menu -cursor boat
+        set i 0
+        foreach label $values {
+            set value $label
+            if {$args ne ""} {set value $i}
+            $name.menu add radiobutton -value $value -variable $variable \
+                -label $label -command "set $textvar \"$label\""
+            incr i
+        }
+    } else {
+        # set combobox width to largest string
+        set width 0
+        foreach value $values {
+            set len [string length $value]
+            set width [expr $len > $width ? $len : $width]
+        }
+        ttk::combobox $name -state readonly -width $width \
+            -style Prefs.TCombobox -values $values
+        set command "get"
+        if {$args ne ""} {
+            set command "current"
+            # the following cmd prevents a bug in the alsa midi api
+            # from throwing an index that's out of range. but once
+            # that bug gets fixed, this should be removed so that
+            # it doesn't hide any future bugs
+            set $variable [expr min([set $variable], [llength $values] - 1)]
+        }
+        bind $name <<ComboboxSelected>> "set $variable \
+            [concat {[} $name $command {]} ]; after 0 {%W selection clear}"
+        if {$command eq "get"} {set command "set"}
+        $name $command [set $variable]
+    }
+}
+
+proc ::dialog_prefs::set_color {array key op} {
+    # not sure if this is necessary, but just in case...
+    if {$op ne "write"} {return}
+    set c [set ${array}($key)]
+    set commands {}
+    switch $key {
+        box {set commands [list "itemconfigure \
+            (obj&&border) -fill $c"] }
+        text { set commands [list "itemconfigure \
+            (text&&(!iemgui))||(label&&graph) -fill $c"]}
+        canvas_bg {set commands [list "configure -bg $c"]}
+        canvas_cursor {set commands [list "configure -insertbackground $c"]}
+        highlighted_text_bg \
+            {set commands [list "configure -selectbackground $c"]}
+        highlighted_text {set commands [list "configure -selectforeground $c"]}
+        msg_box_border {set commands [list "itemconfigure \
+            (msg&&border) -outline $c"]}
+        msg_box {set commands [list "itemconfigure \
+            (msg&&border) -fill $c"]}
+        inlet   {set commands [list "itemconfigure inlet -outline $c"]}
+        outlet  {set commands [list "itemconfigure outlet -outline $c"]}
+        cord_signal {set commands [list "itemconfigure \
+            cord&&signal -fill $c"]}
+        cord_control {set commands [list "itemconfigure \
+            cord&&control -fill $c"]}
+        selected {
+            set commands [list "itemconfigure \
+                selected&&text -fill $c"]
+            lappend commands "itemconfigure \
+                selected&&(border&&(!iemgui)) -fill $c"
+            lappend commands "itemconfigure \
+                selected&&border&&iemgui -outline $c"
+        }
+        box_border {set commands [list "itemconfigure \
+            border&&(!iemgui) -outline $c"]}
+        iemgui_border {
+            set commands [list "itemconfigure border&&iemgui -outline $c"]}
+        atombox {set commands [list "itemconfigure \
+            border&&atom -fill $c"]}
+        atombox_border {set commands [list "itemconfigure \
+            border&&atom -outline $c"]}
+        default {}
+    }
+    if {$commands ne ""} {
+        foreach w [array names ::parentwindows] {
+            foreach child [winfo children $w] {
+                if {[winfo class $child] eq "Canvas"} {
+                    foreach command $commands {
+                        eval $child $command
+                    }
+                }
+            }
+        }
+    }
+    # hack! how do I avoid hard-coding the window name here?
+    set mytoplevel .prefs.nb.gui.colors
+    if {[winfo exists $mytoplevel.$key]} {
+        ::dialog_prefs::set_swatchbutton $mytoplevel.$key ${array}($key)
+    }
+    
+}
+
+proc ::dialog_prefs::set_swatchbutton {name variable} {
+    if {[set $variable] eq ""} {return}
+    image create photo ::img::swatchbutton::$name
+    set c [set $variable]
+    set bd #000000
+    set stupid_top_and_bottom \
+        [list $bd $bd $bd $bd $bd $bd $bd $bd $bd $bd $bd $bd $bd $bd $bd $bd]
+    set dumb \
+        [list $bd $c $c $c $c $c $c $c $c $c $c $c $c $c $c $bd]
+    ::img::swatchbutton::$name put [list $stupid_top_and_bottom \
+        $dumb $dumb $dumb $dumb $dumb $dumb $dumb $dumb $dumb $dumb \
+        $dumb $dumb $dumb $dumb $stupid_top_and_bottom] -to 0 0
+    $name configure -image ::img::swatchbutton::$name
+}
+
+proc ::dialog_prefs::swatchmenu_nav {w dir} {
+    set new [expr {[$w index active] + 7 * $dir}]
+    if {$new > [$w index end] || $new < 0} then return
+    $w activate $new
+}
+
+proc ::dialog_prefs::swatchbutton_colorchooser {name variable} {
+    set col [tk_chooseColor -parent $name]
+    if {$col ne ""} {
+        set $variable $col
+    }
+}
+
+proc ::dialog_prefs::swatchbutton {name variable} {
+    if {$::windowingsystem ne "x11"} {
+        ttk::button $name -command "::dialog_prefs::swatchbutton_colorchooser $name $variable"
+        return
+    }
+    # Tk's color chooser for x11 isn't very good. So instead, the user
+    # gets a matrix of predefined colors to choose from. If a few custom
+    # colors could be added (or maybe triggering Ivica's L2ork color
+    # chooser) this would be improved.
+    ttk::menubutton $name -menu $name.m -style PrefsColors.TMenubutton
+    menu $name.m
+    bind $name.m <Left>  "::dialog_prefs::swatchmenu_nav %W -1"
+    bind $name.m <Right> "::dialog_prefs::swatchmenu_nav %W 1"
+    set i 0
+    foreach swatch [::dialog_prefs::get_colorswatches] {
+        set columnbreak [expr {$i % 7 == 0}]
+        # Note: there is a trace set in pd-gui.tcl that calls
+        # ::dialog_prefs::set_color whenever the value of a
+        # ::pd_colors variable is changed.  So for the menu we just
+        # have to link to one of those variables and trace does the rest
+        $name.m add radiobutton -value $swatch -variable $variable \
+            -image ::img::colorswatches::$swatch -columnbreak $columnbreak \
+            -hidemargin 1
+        incr i
+    }
+}
+    
+
+# These are images used to build the menu for choosing
+# colors. The images hang around in memory until you exit
+# Pd, but they shouldn't take up too much space to matter
+# (and this only gets called once).  If there's a simpler
+# way to build a _straightforward_ _user-friendly_
+# colorchooser that would be nice, but I couldn't figure
+# one out.
+proc ::dialog_prefs::get_colorswatches {} {
+    # stolen from the Firefox colorchooser
+    set colors {  \
+        #ffffff #cfcccc #c0c0c0 #999999 #666666 #333333 #000000 \
+        #ffcccc #ff6666 #ff0000 #cc0000 #990000 #660000 #330000 \
+        #ffcc99 #ff9966 #ff9900 #ff6600 #cc6600 #993300 #663300 \
+        #ffff99 #ffff66 #ffcc66 #ffcc33 #cc9933 #996633 #663333 \
+        #ffffcc #ffff33 #ffff00 #ffcc00 #999900 #666600 #333300 \
+        #99ff99 #66ff99 #33ff33 #33cc00 #009900 #006600 #003300 \
+        #99ffff #33ffff #66cccc #00cccc #339999 #336666 #003333 \
+        #ccffff #66ffff #33ccff #3366ff #3333ff #000099 #000066 \
+        #ccccff #9999ff #6666cc #6633ff #6600cc #333399 #330099 \
+        #ffccff #ff99ff #cc66cc #cc33cc #993399 #663366 #330033 \
+    }
+    if {[lsearch [image names] ::img::colorswatches::*] == -1} {
+        foreach color $colors {
+        image create photo ::img::colorswatches::$color
+        ::img::colorswatches::$color put $color -to 0 0 16 16
+        }
+    }
+    return $colors
+}
+
+proc ::dialog_prefs::help {notebook} {
+    set pane [$notebook select]
+    regsub {.*\.(.*)} $pane {\1} topic
+    set file all_about_${topic}_settings.pd
+    set dir [file join $::sys_libdir doc 5.reference]
+    menu_doc_open $dir $file
+}
+
+proc ::dialog_prefs::create_dialog {mytoplevel} {
+    toplevel .prefs -class DialogWindow
+    wm title .prefs [_ "Pure Data Preferences"]
+#    wm geometry .prefs =475x125+150+150
+    wm group .prefs .
+    wm resizable .prefs 0 0
+    wm transient .prefs
+    .prefs configure -menu $::dialog_menubar
+
+# todo: check this on the mac and on windows
+#    .prefs configure -padx 10 -pady 5
+    ::pd_bindings::dialog_bindings .prefs "prefs"
+    bind .prefs <$::modifier-Key-f> break
+
+    # Ttk style setup
+
+    # Common settings
+    ttk::style configure Prefs.TLabelframe -borderwidth 0
+    # todo: don't hardcode font here
+    ttk::style configure Prefs.TLabelframe.Label \
+        -font "{DejaVu Sans} 9 bold"
+
+    # for OSX swatchbutton
+    if {$::windowingsystem eq "x11"} {
+        # custom arrow image for ttk::combobox
+        set ::prefs_arrowimg [image create photo -data \
+            {R0lGODlhGQAVAMIGACEhIVBQUFpaWl1dXXBwcImJif///////yH+EUNyZWF0ZWQg
+            d2l0aCBHSU1QACH5BAEKAAcALAAAAAAZABUAAAMleLrc/jDKSau9OOutC/ggUGRE
+            CBCbAArcEQBBqwxybd94ru9QAgA7
+        }]
+        # ttk::style theme use clam
+        ttk::style element create Prefs.downarrow image $::prefs_arrowimg
+        ttk::style layout Prefs.TCombobox {
+            Combobox.focus -sticky nsew -children {
+                Combobox.field -sticky nswe -children {
+                    Prefs.downarrow -side right -sticky ns
+                    Combobox.padding -expand 1 -sticky nswe -children {
+                        Combobox.textarea -sticky nswe
+                    }
+                }
+            }
+        }
+        ttk::style layout PrefsColors.TMenubutton {
+            Menubutton.border -sticky nswe -children {
+                Menubutton.focus -sticky nswe -children {
+                    Menubutton.padding -expand 1 -sticky we -children {
+                        Menubutton.label -side left -sticky {}
+                    }
+                }
+            }
+        }
+        ttk::style configure Prefs.TCombobox -padding 3
+        ttk::style map Prefs.TCombobox \
+            -fieldbackground {{readonly pressed} #c1c4c7 \
+                              {readonly hover} #fafaf9 \
+                              readonly #f5f5f4} \
+            -foreground {{readonly focus} black}
+        # this shouldn't be global, but I can't get it to work for just
+        # Prefsdialog class
+        option add *TCombobox*Listbox.selectBackground #4a90d9
+        option add *TCombobox*Listbox.selectForeground white
+    }
+
+    ttk::notebook .prefs.nb
+    .prefs.nb add [ttk::frame .prefs.nb.audio -padding 10] \
+        -text "Audio" -sticky nsew
+    .prefs.nb add [ttk::frame .prefs.nb.midi -padding 10] \
+        -text "MIDI" -sticky nsew
+    .prefs.nb add [ttk::frame .prefs.nb.gui -padding 10] \
+        -text "GUI" -stick nsew
+    pack .prefs.nb -fill both -expand 1
+
+    ttk::frame .prefs.bottomframe -padding 10
+    pack .prefs.bottomframe -side bottom -fill both  -expand 1
+    if {$::windowingsystem ne "aqua"} {
+    ttk::button .prefs.bottomframe.closebutton \
+        -text "Close" -command "::dialog_prefs::cancel .prefs"
+    pack .prefs.bottomframe.closebutton -side right
+    }
+    ttk::button .prefs.bottomframe.helpbutton \
+        -text "Help" -command "::dialog_prefs::help .prefs.nb"
+    pack .prefs.bottomframe.helpbutton -side left
+}
diff -rupN newpd/pd-0.45-0/tcl/pd-gui.tcl pd-0.45-0/tcl/pd-gui.tcl
--- newpd/pd-0.45-0/tcl/pd-gui.tcl	2013-08-09 18:17:07.000000000 -0400
+++ pd-0.45-0/tcl/pd-gui.tcl	2013-08-27 12:37:35.806358982 -0400
@@ -27,6 +27,7 @@ package require pd_connect
 package require pd_menus
 package require pd_bindings
 package require pdwindow
+package require dialog_prefs
 package require dialog_array
 package require dialog_audio
 package require dialog_canvas
@@ -169,6 +170,44 @@ set midi_outdevlist {}
 set pd_whichapi 0
 set pd_whichmidiapi 0
 
+# gui preferences
+# array set pd_colors {
+#    atombox     {gray}
+#    atombox_border {black}
+#    canvas_bg   {white}
+#    canvas_cursor {green}
+#    text        {black}
+#    box_border  {gray}
+#    box          {gray}
+#    msg_box_border {gray}
+#    msg_box       {white}
+#    iemgui_border {gray}
+#    cord_control {black}
+#    cord_signal {black}
+#    inlet       {black}
+#    outlet      {black}
+#    xlet_hover  {blue}
+#    link        {blue}
+#    selected    {blue}
+#    selection_rectangle {black}
+#    highlighted_text_bg {grey}
+#    highlighted_text {black}
+#}
+
+# Add a trace for the color array. This way any gui-plugin can make
+# color changes simply by changing one of the elements of the pd_colors
+# array, and all the preference dialog stuff and open patches will
+# magically update
+trace add variable pd_colors write ::dialog_prefs::set_color
+
+# ... and a trace for the ::gui_preset variable.  There's probably
+# a way to do this inside the dropdown code, which would be better...
+trace add variable gui_preset write "::dialog_gui::set_gui_preset"
+
+# Now that we've got a trace for the colors, we can set a
+# color scheme (defined in dialog_gui.tcl)
+set gui_preset Default
+
 # current state of the DSP
 set dsp 0
 # state of the peak meters in the Pd window
@@ -311,9 +350,9 @@ proc init_for_platform {} {
         }
         "aqua" {
             set ::modifier "Mod1"
-            option add *DialogWindow*background "#E8E8E8" startupFile
-            option add *DialogWindow*Entry.highlightBackground "#E8E8E8" startupFile
-            option add *DialogWindow*Button.highlightBackground "#E8E8E8" startupFile
+#            option add *DialogWindow*background "#E8E8E8" startupFile
+#            option add *DialogWindow*Entry.highlightBackground "#E8E8E8" startupFile
+#            option add *DialogWindow*Button.highlightBackground "#E8E8E8" startupFile
             option add *DialogWindow*Entry.background "white" startupFile
             # Mac OS X needs a menubar all the time
             set ::dialog_menubar ".menubar"
diff -rupN newpd/pd-0.45-0/tcl/pd_menucommands.tcl pd-0.45-0/tcl/pd_menucommands.tcl
--- newpd/pd-0.45-0/tcl/pd_menucommands.tcl	2013-08-07 16:29:37.000000000 -0400
+++ pd-0.45-0/tcl/pd_menucommands.tcl	2013-08-27 12:37:35.806358982 -0400
@@ -101,6 +101,10 @@ proc ::pd_menucommands::menu_send_float
 # ------------------------------------------------------------------------------
 # open the dialog panels
 
+proc ::pd_menucommands::menu_prefs_dialog {} {
+    ::dialog_prefs::open_prefs_dialog $::focused_window
+}
+
 proc ::pd_menucommands::menu_message_dialog {} {
     ::dialog_message::open_message_dialog $::focused_window
 }
diff -rupN newpd/pd-0.45-0/tcl/pd_menus.tcl pd-0.45-0/tcl/pd_menus.tcl
--- newpd/pd-0.45-0/tcl/pd_menus.tcl	2013-08-18 21:38:22.000000000 -0400
+++ pd-0.45-0/tcl/pd_menus.tcl	2013-08-27 17:24:42.084824250 -0400
@@ -64,6 +64,9 @@ proc ::pd_menus::configure_for_pdwindow
     # Undo/Redo change names, they need to have the asterisk (*) after
     $menubar.edit entryconfigure 0 -state disabled -label [_ "Undo"]
     $menubar.edit entryconfigure 1 -state disabled -label [_ "Redo"]
+    if {$::windowingsystem ne "aqua"} {
+        $menubar.edit entryconfigure [_ "Preferences"] -state normal
+    }
     # disable everything on the Put menu
     for {set i 0} {$i <= [$menubar.put index end]} {incr i} {
         # catch errors that happen when trying to disable separators
@@ -83,6 +86,9 @@ proc ::pd_menus::configure_for_canvas {m
     $menubar.edit entryconfigure [_ "Tidy Up"] -state normal
     $menubar.edit entryconfigure [_ "Edit Mode"] -state normal
     pdtk_canvas_editmode $mytoplevel $::editmode($mytoplevel)
+    if {$::windowingsystem ne "aqua"} {
+        $menubar.edit entryconfigure [_ "Preferences"] -state normal
+    }
     # Put menu
     for {set i 0} {$i <= [$menubar.put index end]} {incr i} {
         # catch errors that happen when trying to disable separators
@@ -112,6 +118,9 @@ proc ::pd_menus::configure_for_dialog {m
     # Undo/Redo change names, they need to have the asterisk (*) after
     $menubar.edit entryconfigure 0 -state disabled -label [_ "Undo"]
     $menubar.edit entryconfigure 1 -state disabled -label [_ "Redo"]
+    if {$::windowingsystem ne "aqua"} {
+        $menubar.edit entryconfigure [_ "Preferences"] -state disabled
+    }
     # disable everything on the Put menu
     for {set i 0} {$i <= [$menubar.put index end]} {incr i} {
         # catch errors that happen when trying to disable separators
@@ -178,9 +187,8 @@ proc ::pd_menus::build_edit_menu {mymenu
         -variable ::editmode_button \
         -command {menu_editmode $::editmode_button}
     if {$::windowingsystem ne "aqua"} {
-        $mymenu add  separator
-        create_preferences_menu $mymenu.preferences
-        $mymenu add cascade -label [_ "Preferences"] -menu $mymenu.preferences
+        $mymenu add command -label [_ "Preferences"] \
+            -command {menu_prefs_dialog}
     }
 }
 
@@ -245,29 +253,6 @@ proc ::pd_menus::build_media_menu {mymen
         -command {menu_doc_open doc/7.stuff/tools testtone.pd} 
     $mymenu add command -label [_ "Load Meter"] \
         -command {menu_doc_open doc/7.stuff/tools load-meter.pd} 
-
-    set audio_apilist_length [llength $::audio_apilist]
-    if {$audio_apilist_length > 0} {$mymenu add separator}
-    for {set x 0} {$x<$audio_apilist_length} {incr x} {
-        $mymenu add radiobutton -label [lindex [lindex $::audio_apilist $x] 0] \
-            -command {menu_audio 0} -variable ::pd_whichapi \
-            -value [lindex [lindex $::audio_apilist $x] 1]\
-            -command {pdsend "pd audio-setapi $::pd_whichapi"}
-    }
-    
-    set midi_apilist_length [llength $::midi_apilist]
-    if {$midi_apilist_length > 0} {$mymenu add separator}
-    for {set x 0} {$x<$midi_apilist_length} {incr x} {
-        $mymenu add radiobutton -label [lindex [lindex $::midi_apilist $x] 0] \
-            -command {menu_midi 0} -variable ::pd_whichmidiapi \
-            -value [lindex [lindex $::midi_apilist $x] 1]\
-            -command {pdsend "pd midi-setapi $::pd_whichmidiapi"}
-    }
-
-    $mymenu add command -label [_ "Audio Settings..."] \
-        -command {pdsend "pd audio-properties"}
-    $mymenu add command -label [_ "MIDI Settings..."] \
-        -command {pdsend "pd midi-properties"}
 }
 
 proc ::pd_menus::build_window_menu {mymenu} {
@@ -494,6 +479,9 @@ proc ::pd_menus::create_preferences_menu
 
 # for Mac OS X only
 proc ::pd_menus::create_apple_menu {mymenu} {
+    # this proc add calls to it can probably
+    # just be removed
+    return
     # TODO this should open a Pd patch called about.pd
     menu $mymenu.apple
     $mymenu.apple add command -label [_ "About Pd"] -command {menu_aboutpd}
diff -rupN newpd/pd-0.45-0/tcl/pdtk_canvas.tcl pd-0.45-0/tcl/pdtk_canvas.tcl
--- newpd/pd-0.45-0/tcl/pdtk_canvas.tcl	2013-08-18 21:38:22.000000000 -0400
+++ pd-0.45-0/tcl/pdtk_canvas.tcl	2013-08-27 12:37:35.810358899 -0400
@@ -83,10 +83,11 @@ proc pdtk_canvas_new {mytoplevel width h
     wm minsize $mytoplevel $::canvas_minwidth $::canvas_minheight
 
     set tkcanvas [tkcanvas_name $mytoplevel]
-    canvas $tkcanvas -width $width -height $height \
+    canvas $tkcanvas -width $width -height $height -bg $::pd_colors(canvas_bg) \
         -highlightthickness 0 -scrollregion [list 0 0 $width $height] \
         -xscrollcommand "$mytoplevel.xscroll set" \
-        -yscrollcommand "$mytoplevel.yscroll set"
+        -yscrollcommand "$mytoplevel.yscroll set" \
+        -insertbackground $::pd_colors(canvas_cursor)
     scrollbar $mytoplevel.xscroll -orient horizontal -command "$tkcanvas xview"
     scrollbar $mytoplevel.yscroll -orient vertical -command "$tkcanvas yview"
     pack $tkcanvas -side left -expand 1 -fill both
diff -rupN newpd/pd-0.45-0/tcl/pdtk_text.tcl pd-0.45-0/tcl/pdtk_text.tcl
--- newpd/pd-0.45-0/tcl/pdtk_text.tcl	2013-08-07 16:29:37.000000000 -0400
+++ pd-0.45-0/tcl/pdtk_text.tcl	2013-08-27 12:37:35.810358899 -0400
@@ -5,7 +5,9 @@ package provide pdtk_text 0.1
 # are used by 'pd' and therefore need to be in the global namespace.
 
 # create a new text object (ie. obj, msg, comment)
-proc pdtk_text_new {tkcanvas tags x y text font_size color} {
+proc pdtk_text_new {tkcanvas tags x y text font_size isselected} {
+    set color $::pd_colors(text)
+    if {$isselected} {set color $::pd_colors(selected)}
     $tkcanvas create text $x $y -tags $tags -text $text -fill $color \
         -anchor nw -font [get_font_for_size $font_size]
     set mytag [lindex $tags 0]
diff -rupN newpd/pd-0.45-0/tcl/pkgIndex.tcl pd-0.45-0/tcl/pkgIndex.tcl
--- newpd/pd-0.45-0/tcl/pkgIndex.tcl	2013-08-07 16:29:37.000000000 -0400
+++ pd-0.45-0/tcl/pkgIndex.tcl	2013-08-27 12:37:35.810358899 -0400
@@ -13,6 +13,7 @@ package ifneeded pd_bindings 0.1 [list s
 package ifneeded pd_connect 0.1 [list source [file join $dir pd_connect.tcl]]
 package ifneeded dialog_array 0.1 [list source [file join $dir dialog_array.tcl]]
 package ifneeded dialog_audio 0.1 [list source [file join $dir dialog_audio.tcl]]
+package ifneeded dialog_gui 0.1 [list source [file join $dir dialog_gui.tcl]]
 package ifneeded dialog_canvas 0.1 [list source [file join $dir dialog_canvas.tcl]]
 package ifneeded dialog_data 0.1 [list source [file join $dir dialog_data.tcl]]
 package ifneeded dialog_find 0.1 [list source [file join $dir dialog_find.tcl]]
@@ -22,6 +23,7 @@ package ifneeded dialog_iemgui 0.1 [list
 package ifneeded dialog_message 0.1 [list source [file join $dir dialog_message.tcl]]
 package ifneeded dialog_midi 0.1 [list source [file join $dir dialog_midi.tcl]]
 package ifneeded dialog_path 0.1 [list source [file join $dir dialog_path.tcl]]
+package ifneeded dialog_prefs 0.1 [list source [file join $dir dialog_prefs.tcl]]
 package ifneeded dialog_startup 0.1 [list source [file join $dir dialog_startup.tcl]]
 package ifneeded helpbrowser 0.1 [list source [file join $dir helpbrowser.tcl]]
 package ifneeded opt_parser 0.1 [list source [file join $dir opt_parser.tcl]]
